Name:       capi-appfw-app-control
Summary:    App control API
Version:    0.11.13
Release:    0
Group:      System/API
License:    Apache-2.0
Source0:    %{name}-%{version}.tar.gz
Source1001:     capi-appfw-app-control.manifest
BuildRequires:  cmake
BuildRequires:  pkgconfig(dlog)
BuildRequires:  pkgconfig(bundle)
BuildRequires:  pkgconfig(aul)
BuildRequires:  pkgconfig(capi-base-common)
BuildRequires:  pkgconfig(appcore-common)
BuildRequires:  pkgconfig(gmock)
%if 0%{?gcov:1}
BuildRequires:  lcov
BuildRequires:  zip
%endif

Recommends:   amd-mod-share

%description
An Application Control library in Tizen C API

%package devel
Summary:  An Application Control library in Tizen C API (Development)
Group:    System/API
Requires: %{name} = %{version}-%{release}

%description devel
An Application Control library in Tizen C API (Development) package.

#################################################
# unittests
#################################################
%package unittests
Summary:    GTest for uri
Group:      Development/Libraries
Requires:   %{name}

%description unittests
GTest for app_control

#################################################
# gcov
#################################################
%if 0%{?gcov:1}
%package gcov
Summary:    app_control(gcov)
Group:      Application Framework/Testing

%description gcov
app_control gcov objects
%endif

%prep
%setup -q
cp %{SOURCE1001} .

%build
%if 0%{?gcov:1}
export CFLAGS+=" -fprofile-arcs -ftest-coverage"
export CXXFLAGS+=" -fprofile-arcs -ftest-coverage"
export FFLAGS+=" -fprofile-arcs -ftest-coverage"
export LDFLAGS+=" -lgcov"
%endif

MAJORVER=`echo %{version} | awk 'BEGIN {FS="."}{print $1}'`
%cmake . -DFULLVER=%{version} -DMAJORVER=${MAJORVER}
%__make %{?_smp_mflags}

%if 0%{?gcov:1}
mkdir -p gcov-obj
find . -name '*.gcno' -exec cp '{}' gcov-obj ';'
%endif

%check
ctest --output-on-failure %{?_smp_mflags}
%if 0%{?gcov:1}
lcov -c --ignore-errors graph --no-external -q -d . -o app_control.info
genhtml app_control.info -o app_control.out
zip -r app_control.zip app_control.out
install -m 0644 app_control.zip %{buildroot}%{_datadir}/gcov/app_control.zip
%endif

%install
rm -rf %{buildroot}
%make_install

%if 0%{?gcov:1}
mkdir -p %{buildroot}%{_datadir}/gcov/obj
install -m 0644 gcov-obj/* %{buildroot}%{_datadir}/gcov/obj
%endif

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post unittests
%if 0%{?gcov:1}
%{_bindir}/appctrl_unittests
%endif

%files
%manifest %{name}.manifest
%{_libdir}/libcapi-appfw-app-control.so.*
%{_libdir}/libcapi-appfw-app-control-uri.so.*
%license LICENSE

%files devel
%manifest %{name}.manifest
%{_includedir}/appfw/app_control.h
%{_includedir}/appfw/app_control_internal.h
%{_includedir}/appfw/app_control_uri.h
%{_libdir}/pkgconfig/capi-appfw-app-control.pc
%{_libdir}/libcapi-appfw-app-control.so
%{_libdir}/libcapi-appfw-app-control-uri.so

#################################################
# unittests
#################################################
%files unittests
%{_bindir}/appctrl_unittests

#################################################
# uri-gcov
#################################################
%if 0%{?gcov:1}
%files gcov
%{_datadir}/gcov/*
%endif
